import numpy
from scipy import *
from pylab import *
import time
from scipy import weave
from scipy.weave import converters



n=32

beta = 1.0/3.8
dim=2;
s = zeros((n,n,2),dtype=float)
s[:,:,0] = 1.0
size = 0.1;

def energy(s): 
   e = zeros((n,n))
   for i in range(dim): 
      e[1:-1, 1:-1] += -(s[0:-2, 1:-1, i] + s[2:, 1:-1, i]+ s[1:-1, 0:-2, i] + s[1:-1, 2:, i])*s[1:-1, 1:-1, i]
   return e

def iterate(s,beta):
   r = random((n,n))

   code = """
       #line 28 "xy.py"
       #include <math.h>
       //srand(1329);
       int mod = n-1;
       for(int x=0; x < n; x++) {
	  for(int y=0; y < n; y++) {
	     float field[dim];
	     float s_new[dim];

	     float norm = 0;

	     while(1) {
	     for(int i=0; i < dim; i++){
		s_new[i] = rand()/(RAND_MAX+1.0)-0.5;
		norm += s_new[i]*s_new[i];
	     }
	     if (norm < 1)
		break;
	     }

	     for(int i=0; i < dim; i++){
		s_new[i] = s(x,y,i) + size*s_new[i];
		norm += s_new[i]*s_new[i];
	     }

	     norm = 1.0/sqrt(norm);

	     for(int i=0; i < dim; i++){
		s_new[i] *= norm;
	     }

	     for(int i=0; i < dim; i++){
		field[i] = s(((x+1)&mod),y,i) + s(((x-1)&mod),y,i) + s(x,((y+1)&mod),i) + s(x,((y-1)&mod),i);
	     }

	     float delta_e = 0.0; 
	     for(int i=0; i < dim; i++){
		delta_e += -field[i]*(s_new[i]-s(x,y,i));
	     }
	     if (exp(-beta*delta_e) > r(x,y)) {
		for(int i=0; i < dim; i++){
		   s(x,y,i) = s_new[i];
		}
	     }
	  }
       }
           """
   weave.inline(code, ['s', 'r', 'beta', 'n', 'dim', 'size'], type_converters=converters.blitz, compiler = 'gcc')
   return


ion()
       
#figure()
for k in range(10000):
       iterate(s,beta)
       if (k%1000 == 0) :
          #cla()
          quiver(s[:,:,0],s[:,:,1],pivot='mid')
	  #e = energy(s)
          #imshow(e)



